<?php
namespace Bushelpowered\Api\Fulfillment\Contract\V1\Response;
        
class PricingLineResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    public int $id;
    public string $remoteId;
    public ?string $displayId = null;
    public ?int $sequenceNumber = null;
    /** @var null|string $deliveryPeriodStart of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deliveryPeriodStart = null;
    /** @var null|string $deliveryPeriodEnd of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deliveryPeriodEnd = null;
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $location;
    public ?float $quantityPriced = null;
    public ?string $quantityUom = null;
    public ?float $futuresPrice = null;
    public ?float $basis = null;
    public ?float $cashPrice = null;
    public ?string $futuresMonth = null;
    public ?string $pricingStatus = null;
    public ?string $signatureStatus = null;
    /** @var null|string $remoteCreatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $remoteCreatedAt = null;
    /** @var null|string $remoteUpdatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $remoteUpdatedAt = null;
    /** @var string $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  null|string  $deliveryPeriodStart of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $deliveryPeriodEnd of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $remoteCreatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $remoteUpdatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(int $id, string $remoteId, ?string $displayId, ?int $sequenceNumber, ?string $deliveryPeriodStart, ?string $deliveryPeriodEnd, \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $location, ?float $quantityPriced, ?string $quantityUom, ?float $futuresPrice, ?float $basis, ?float $cashPrice, ?string $futuresMonth, ?string $pricingStatus, ?string $signatureStatus, ?string $remoteCreatedAt, ?string $remoteUpdatedAt, string $createdAt, string $updatedAt)
    {
        $this->id = $id;
        $this->remoteId = $remoteId;
        $this->displayId = $displayId;
        $this->sequenceNumber = $sequenceNumber;
        $this->deliveryPeriodStart = $deliveryPeriodStart;
        $this->deliveryPeriodEnd = $deliveryPeriodEnd;
        $this->location = $location;
        $this->quantityPriced = $quantityPriced;
        $this->quantityUom = $quantityUom;
        $this->futuresPrice = $futuresPrice;
        $this->basis = $basis;
        $this->cashPrice = $cashPrice;
        $this->futuresMonth = $futuresMonth;
        $this->pricingStatus = $pricingStatus;
        $this->signatureStatus = $signatureStatus;
        $this->remoteCreatedAt = $remoteCreatedAt;
        $this->remoteUpdatedAt = $remoteUpdatedAt;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}