<?php
namespace Bushelpowered\Api\Platform\Authorization\V1\Model;
        
class IdentifierAccountStandard implements \Bushelpowered\Api\Common\HasTimestamps, \Bushelpowered\Api\Common\Event\StandardRecord
{
    public string $id;
    public string $tenantId;
    public string $datasourceId;
    public string $integrationId;
    public string $idpSlug;
    public string $userIdpId;
    public string $identifierIntegrationId;
    public ?string $identifierName = null;
    public string $accountId;
    public string $accountIntegrationId;
    public string $sourceAccountId;
    /** @var string $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;
    /** @var null|string $deletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deletedAt = null;
    public string $sourceId;
    public ?string $locationId = null;

    /**
     * @param  string  $createdAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $deletedAt of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $tenantId, string $datasourceId, string $integrationId, string $idpSlug, string $userIdpId, string $identifierIntegrationId, ?string $identifierName, string $accountId, string $accountIntegrationId, string $sourceAccountId, string $createdAt, string $updatedAt, ?string $deletedAt, string $sourceId, ?string $locationId)
    {
        $this->id = $id;
        $this->tenantId = $tenantId;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->idpSlug = $idpSlug;
        $this->userIdpId = $userIdpId;
        $this->identifierIntegrationId = $identifierIntegrationId;
        $this->identifierName = $identifierName;
        $this->accountId = $accountId;
        $this->accountIntegrationId = $accountIntegrationId;
        $this->sourceAccountId = $sourceAccountId;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->deletedAt = $deletedAt;
        $this->sourceId = $sourceId;
        $this->locationId = $locationId;
    }
    
    public function getId(): string
    {
        return $this->id;
    }
    public function getTenantId(): string
    {
        return $this->tenantId;
    }
    public function getDatasourceId(): string
    {
        return $this->datasourceId;
    }
    public function getIntegrationId(): string
    {
        return $this->integrationId;
    }
    public function getAccountId(): string
    {
        return $this->accountId;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
    /**
     * @return null|string of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getDeletedAt(): ?string
    {
        return $this->deletedAt;
    }
    public function getSourceId(): string
    {
        return $this->sourceId;
    }
    public function getLocationId(): ?string
    {
        return $this->locationId;
    }
}